/*
 * kner 2019
 * PINCHANGE Interrupt Example
 * ein Zähler zählt das obere Nibble von PORTB laufend hoch (0,1...13,14,15,0,1,...)
 * Bei Tastendruck PC0 wird ein Interrupt ausgelöst, der den Startwert 
 * des Zählers neu setzt. Dieser Startwert liegt am unteren Nibble von PORTB an. 
 */ 

#define F_CPU 16000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

volatile uint8_t startvalue=0; 
void setup(); 
int main(void)
{   uint8_t count = -1; 
    setup(); 
	sei(); 
    while (1) 
    { 
		count++;
		if (count == 16) //overflow 
		   count = startvalue; 
		count = count % 16; 		
		// set upper nibble 
		PORTB = count << 4; // lower nibble = 0 is o.k.
		//_delay_ms(1000); 
    }
}
ISR (PCINT1_vect){
	// key pressed (not released)
	if (!(PINC & (1<<PINC0)))
	  startvalue = PINB & 0x0F; 
}
void setup(){
	PORTC=0xFF; //all pullups
	DDRB=0xF0;  //upper nibble outputs
	// PinChange allow
	PCMSK1 |= (1<<PCINT8); // PC0 allow Pinchange int
	PCICR |= (1<<PCIE1);   // allow corresponding pin group
}

